﻿namespace Fadd
{
	/// <summary>
	/// Used for components that need to get a start or stop signal.
	/// </summary>
	public interface IStartable
	{
		/// <summary>
		/// Start component
		/// </summary>
		void Start();

		/// <summary>
		/// Stop component
		/// </summary>
		void Stop();
	}
}
