using System;
using Fadd.Logging;

namespace Fadd.Logging
{
	/// <summary>
	/// Simple wrapper to be able to provide logging objects even if no logging framework have been specified.
	/// </summary>
	internal class NullLogManager : ILogManager
	{
		private static NullLogger _logger = new NullLogger();

		public ILogger GetLogger(Type type)
		{
			return _logger;
		}
	}
}