﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Fadd.Logging;
using Xunit;

namespace Fadd.Test.Logging
{

    public class ConfigTester
    {

        [Fact]
        public void Test()
        {
            Configure.Fadd.Logging()
                .LogNamespace("Fadd.Test").AndSubNamespaces.ToTargetNamed("Console")
                .LogNamespace("System").AndSubNamespaces.ToTargetNamed("DefaultFile")
                .AddTarget("Console")
                    .As.ConsoleLogger().Filter.OnLogLevelBetween(LogLevel.Info, LogLevel.Warning).Done
                .AddTarget("DefaultFile")
                    .As.FileLogger("ErrorsOnly").Filter.OnLogLevelBetween(LogLevel.Debug, LogLevel.Warning)
                    .As.FileLogger("Everything");

            var generated = Fadd.Logging.Configuration._generated;
        }
    }
}
