using System;

namespace Fadd.IO.Consoles
{
    /// <summary>
    /// Something have been written to the console window
    /// </summary>
    public class OutputEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OutputEventArgs"/> class.
        /// </summary>
        /// <param name="output">The output.</param>
        public OutputEventArgs(ConsoleOutput output)
        {
            Output = output;
        }

        public ConsoleOutput Output { get; set; }
    }
}