using System;

namespace Fadd.Net
{
	internal class FileHeader
	{
		/// <summary>
		/// Gets or sets file name.
		/// </summary>
		public string FileName { get; set; }

		/// <summary>
		/// Gets or sets file size.
		/// </summary>
		public int Size { get; set; }

		/// <summary>
		/// Gets or sets when file was last modified.
		/// </summary>
		public DateTime ModifiedAt { get; set; }
	}
}