﻿using System;

namespace Fadd.Remoting
{
	/// <summary>
	/// Reply to a <see cref="MethodCall"/>
	/// </summary>
	[Serializable]
	public class MethodCallReply : Response
	{
        /// <summary>
        /// Initializes a new instance of the <see cref="MethodCallReply"/> class.
        /// </summary>
        /// <param name="requestId">The request id.</param>
		public MethodCallReply(int requestId) : base(requestId)
		{}

		/// <summary>
		/// Gets or sets result by method call.
		/// </summary>
		public object Result { get; set; }

	}
}
