﻿using System;
using Fadd.Messaging;

namespace Fadd.IO.Consoles
{
	/// <summary>
	/// Console class
	/// </summary>
	public interface IConsole
	{
        /// <summary>
        /// Write a line to the console.
        /// </summary>
        /// <param name="color">Console color</param>
        /// <param name="value">Text to write</param>
		void WriteLine(ConsoleColor color, string value);

        /// <summary>
        /// Write a line to the console
        /// </summary>
        /// <param name="value">Line to write</param>
		void WriteLine(string value);
	}
}
