﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Fadd.InversionOfControl
{
    public class ServiceMapping
    {
        public Type ServiceType { get; set; }

        public Func<object> FactoryMethod { get; set; }

        public List<Type> Implementations
        {
            get { return _implementations; }
        }

        private Action<object> _factory;
        private List<Type> _implementations = new List<Type>();

        public ServiceMapping(Type serviceType)
        {
            ServiceType = serviceType;
        }

        public void AddImplementation(Type concreteType)
        {
            _implementations.Add(concreteType);
        }
    }
}
