namespace Fadd.Net
{
    /// <summary>
    /// How to treat lost connections
    /// </summary>
    public enum ConnectionPolicy
    {
        /// <summary>
        /// Don't do anything special
        /// </summary>
        None,

        /// <summary>
        /// Try to reconnect 
        /// </summary>
        /// <remarks>
        /// Will attempt to reconnect every five second.
        /// </remarks>
        Reconnect,
    }
}