﻿using System;

namespace Fadd.Remoting
{
    /// <summary>
    /// Packet carrying any object
    /// </summary>
    [Serializable]
    public class Packet
    {
        /// <summary>
        /// Gets or sets id identifying this request.
        /// </summary>
        public int RequestId { get; set; }

        /// <summary>
        /// Gets or sets transported object
        /// </summary>
        public object Value { get; set; }
    }
}
